from matplotlib.pyplot import matshow, show

# l’entrée est en haut à gauche
# et la sortie en bas à droite
M = [[0, 0, 0, 1, 0, 0, 0, 0, 1, 0],
     [0, 1, 0, 1, 0, 1, 1, 1, 1, 0],
     [0, 1, 0, 0, 0, 0, 0, 0, 1, 0],
     [1, 1, 1, 1, 1, 0, 1, 1, 1, 0],
     [0, 1, 0, 0, 0, 0, 1, 0, 0, 0],
     [0, 0, 0, 1, 0, 1, 1, 0, 1, 0],
     [1, 1, 0, 1, 0, 0, 1, 0, 1, 0],
     [1, 1, 1, 1, 0, 1, 1, 0, 1, 0],
     [0, 0, 0, 0, 0, 0, 0, 0, 1, 0]]


def print_labyrinthe(M):
    m = list(map(lambda liste: list(map(lambda x: 10*(1 - x), liste)), M))
    m[0][0] = 5
    m[-1][-1] = 5
    matshow(m)
    show()


def add_walls(mat):
    wall_up_down = [[1]*(len(mat)+1)]
    mat_with_walls_up_down = wall_up_down+mat+wall_up_down
    mat_with_side_walls = list(
                            map(lambda liste: [1] + liste + [1],
                                mat_with_walls_up_down))
    return mat_with_side_walls


def labyrinthe(M, debug=False):
    m = add_walls(M)
    x, y = 1, 1
    pile = []
    while (x != len(m) - 2) or (y != len(m[0]) - 2):
        m[x][y] = 5
        if (m[x + 1][y] == 0):
            x += 1
            pile.append((1, 0))
        elif (m[x - 1][y] == 0):
            x -= 1
            pile.append((-1, 0))
        elif (m[x][y + 1] == 0):
            y += 1
            pile.append((0, 1))
        elif (m[x][y - 1] == 0):
            y -= 1
            pile.append((0, -1))
        else:
            m[x][y] = 8
            dx, dy = pile.pop()
            x -= dx
            y -= dy
        if debug:
            print_labyrinthe(m)
    return m


print_labyrinthe(M)

print_labyrinthe(add_walls(M))

print_labyrinthe(labyrinthe(M))

labyrinthe(M, True)
