from matplotlib.pyplot import matshow, show, subplots
from matplotlib.animation import ArtistAnimation

# l’entrée est en haut à gauche
# et la sortie en bas à droite
M = [[0, 0, 0, 1, 0, 0, 0, 0, 1, 0],
     [0, 1, 0, 1, 0, 1, 1, 1, 1, 0],
     [0, 1, 0, 0, 0, 0, 0, 0, 1, 0],
     [1, 1, 1, 1, 1, 0, 1, 1, 1, 0],
     [0, 1, 0, 0, 0, 0, 1, 0, 0, 0],
     [0, 0, 0, 1, 0, 1, 1, 0, 1, 0],
     [1, 1, 0, 1, 0, 0, 1, 0, 1, 0],
     [1, 1, 1, 1, 0, 1, 1, 0, 1, 0],
     [0, 0, 0, 0, 0, 0, 0, 0, 1, 0]]

animation = []
fig, ax = subplots()


def print_labyrinthe(M):
    m = list(map(lambda liste: list(map(lambda x: 10*(1 - x), liste)), M))
    m[0][0] = 5
    m[-1][-1] = 5
    matshow(m)


def add_walls(mat):
    wall_up_down = [[1]*(len(mat)+1)]
    mat_with_walls_up_down = wall_up_down+mat+wall_up_down
    mat_with_side_walls = list(
                            map(lambda liste: [1] + liste + [1],
                                mat_with_walls_up_down))
    return mat_with_side_walls


def labyrinthe(M):
    m = add_walls(M)
    x, y = 1, 1
    pile = []
    while (x != len(m) - 2) or (y != len(m[0]) - 2):
        m[x][y] = 5
        if (m[x + 1][y] == 0):
            x += 1
            pile.append((1, 0))
        elif (m[x - 1][y] == 0):
            x -= 1
            pile.append((-1, 0))
        elif (m[x][y + 1] == 0):
            y += 1
            pile.append((0, 1))
        elif (m[x][y - 1] == 0):
            y -= 1
            pile.append((0, -1))
        else:
            m[x][y] = 8
            dx, dy = pile.pop()
            x -= dx
            y -= dy
        animation.append([ax.imshow(m, animated=True)])
    m[x][y] = 5
    animation.append([ax.imshow(m, animated=True)])


labyrinthe(M)

ani = ArtistAnimation(fig, animation,
                      interval=100, blit=True, repeat=False)
show()
